\section{Introduction to Ethical Hacking}
\begin{description}
 	\item[Hacking]\hfill \\
	Exploiting vulnerabilities in systems and/or software to gain unauthorized acces. Security control compromise.  Produce behaviours outside of system/software's original intent.
	\item[Hacking]\hfill \\
	Using tools and techniques to validate, audit and report on system/software vulnerabilities. Vulnerability existence reporting.
\end{description}

\includegraphics[width=0.5\linewidth]{hackertypes} 

There are legal acpects of penetration testing. Always make sure there is a Statement of Work (SoW) and a Non Disclosure agreement (NDA).\\
\includegraphics[width=0.5\linewidth]{pencycle} \\
There are multiple methodologies for hacking, for example NIST 800-115 or the EC council system hacking methodology.
\subsection{Malicious Code}
Malicious code objects are computer security threats that exploit various network, operating system and software vulnerabilities to spread malicious payloads to computer systems. Most of the computer viruses and Trojan horses depend on irresponsible computer use by humans in order to spread from system to system.
\subsubsection{Zero-day attack}
Zero-day vulnerabilities are security flaws discovered by hackers that have not been thoroughly addressed by the security community. The delay between the discovery of a new type of malicious code and the issuance of patches and antivirus updates is known as the window of vulnerability.
\subsubsection{Source of code: Script kiddie}
Anyone with a minimal level of technical expertise can create a virus and unleash it upon the internet. The script kiddie downloads ready-to-use software (or scripts) from the internet and launches attacks against remote systems. The tools used by script kiddies are freely available to Black Hat hackers.
\subsubsection{Source of code: Drive-by download}
A drive-by download refers to the unintentional download of malicious code to your computer or mobile device that leaves you open to a cyberattack. You don't have to click on anything, press download, or open a malicious email attachment to become infected. A drive-by download can take advantage of an app, operating system, or web browser that contains security flaws due to unsuccessful updates or lack of updates.
\subsubsection{Advanced persistent threat (APT)}
APTs are sophisticated adversaries with advanced technical skills and significant financial resources. These attackers are often military units, intelligence agencies, or shadowy groups that are likely affiliated with government agencies.One of the key differences between APT attackers and other malware authors is that these malware developers often have access to zero-day exploits that are not known to software vendors. Malware built by APTs is highly targeted, designed to impact only a small number of adversary systems and difficult to defeat. Example: APT Case RUAG, Stuxnet.
\subsubsection{Viruses}
As with biological viruses, computer viruses have two main functions, propagation and destruction. According to Symantec, one of the major antivirus software vendors, 200,000 new malware variants appear on the internet every day! The propagation function defines how the virus will spread from system to system.  The destructive power is delivered by the virus’s payload by implementing whatever malicious activity the virus writer had in mind.
\section*{Virus propagation techniques}
By definition, a virus must contain technology that enables it to spread from system to system. Once the virus has “touched” a new system, they use one of several propagation techniques to infect the new victim and expand their reach.
\subsubsection{Master Boot Record infection}
The Master Boot Record (MBR) viruses attack the portion of bootable media that the computer uses to load the operating system during the boot process (hard disk, Universal Serial Bus (USB). The MBR doesn't contain all the code required to implement the virus’s propagation and destructive functions. (MBR size is 512 bytes) The system reads the infected MBR. The virus instructs it to read and execute the code stored in this alternate location. The system loads the entire virus into memory.
\subsubsection{File Infection}
The file infector viruses infect executable files. For Windows-based systems, the names of these files end with .com .exe and .bat extensions.  These viruses are often self-contained executable files that escape detection by using a filename similar to a legitimate operating system file (also called companion virus).  Standard file infector viruses are often easily detected by comparing hash values.
\subsubsection{Sevice Injection}
The Service Injection viruses inject themselves into trusted runtime processes of the operating system, such as svchost.exe, winlogin.exe, and explorer.exe.  
\subsubsection{Macro infection}
 A macro virus is a virus that is written in a macro language, a programming language which is embedded inside a software application word processors and spreadsheet applications. Macro programs are embedded in documents and the macros are run automatically when the document is opened.
\subsection{Malware Technologies}
\subsubsection{Multipartite Viruses}
Multipartite viruses use more than one propagation technique in an attempt to penetrate systems that defend against only one method or the other. Example: The Marzia virus: It infects the command.com system file qualifying it as a file infector virus.  2 hours after the first infection, it writes malicious code to the system’s master boot record qualifying it as a boot sector virus.
\subsubsection{Stealth Viruses}
Stealth viruses hide themselves and fool antivirus packages into thinking that everything is functioning normally.  Example: A stealth boot sector virus might overwrite the system’s MBR with malicious code and modify the operating system’s file access functionality.
\subsubsection{Polymorphic Viruses}
Polymorphic viruses modify their own code as they travel from system to system. The signature of the virus is somewhat different each time it infects a new system. This constantly changing signature will render signature-based antivirus packages useless.
\subsubsection{Encrypted Viruses}
Encrypted viruses use cryptographic techniques to avoid detection. Encrypted viruses use a very short segment of code known as the virus decryption routine. Each infection utilizes a different cryptographic key, causing the main code to appear completely different on each system.
\subsubsection{Logic Bombs}
Logic bombs are malicious code objects that infect a system and lie dormant until they are triggered by the occurrence of one or more conditions such as time, program launch, website logon. Example: The Michelangelo virus:  It infected a system’s MBR, it hid itself until March 6—the birthday of the famous Italian sculptor Michelangelo, On that date, it reformatted the hard drives of infected systems and destroying all the data they contained.
\subsubsection{Trojan Horses}
A Trojan horse is a software program that appears "kind" but carries a malicious, behind-the-scenes payload. 
\subsubsection{Keystroke logging}
 It is the action of recording (logging) the keys struck on a keyboard. The person using the keyboard is unaware that their actions are being monitored. Data can then be retrieved by the person operating the logging program.
\subsubsection{Ransomware}
Ransomware infects a target machine and then uses encryption technology to encrypt files stored on the system with a key known only to the malware creator. The user is unable to access their files and receives a pop-up message warning that the files will be permanently deleted unless a ransom is paid within a short period of time. 
\subsubsection{Worms}
Worms are malicious code objects that propagate themselves without requiring any human intervention. Example: Code Red Worm: Code Red performed three malicious actions on the systems it penetrated: 1. It seeks many new targets by randomly selected hundreds of Internet Protocol (IP) addresses and then probed those addresses to see whether they were used by hosts running a vulnerable version of IIS. 2. It defaced HTML pages on the local web server, replacing normal content with the following text: Welcome to http://www.worm.com!Hacked By Chinese! 3. It planted a logic bomb that would initiate a denial-of-service attack against the IP address 198.137.240.91, which at that time belonged to the web server hosting the White House’s home page.
\subsubsection{Spyware and Adware}
 Spyware monitors your actions and transmits important details to a remote system that spies on your activity.  Adware uses a variety of techniques to display advertisements on infected computers. The simplest forms of adware display pop-up ads on your screen while you surf the web.  More advanced versions may monitor your shopping behavior and redirect you to competitor websites.  Adware often take advantage of third-party plug-ins to web browsers, to spread their malicious content.
\subsection{Antivirus}
An Antivirus software is a computer program used to prevent, detect, and remove malware. If possible, the antivirus package eradicates the virus, disinfects the affected files and restores the machine to a safe condition.  If the software doesn’t know how to remove the virus, the files can be quarantined. A common strategy is to send the suspicious files to a sandbox where they are executed in an isolated but monitored environment. If the software doesn’t know how to remove the virus and cannot be quarantined, the infected files can be deleted in an attempt to preserve system integrity. Antivirus solutions are not only protecting systems from viruses. These tools are often able to provide protection against worms, Trojan horses, logic bombs, rootkits, spyware etc.
\subsubsection{Antivirus detection: signature-based}
The vast majority of the antivirus packages utilize a method known as signature-based detection.  An antivirus package maintains an extremely large database that contains the characteristics of all known viruses. 
\subsubsection{Antivirus detection: heuristic-based}
The antivirus analyze the behavior of software, looking for the signs of virus activity.  Such as attempts to elevate privilege level, coverage of electronic tracks, and alteration unrelated or operating system files. If the software behaves suspiciously in that environment, it is added to blacklists throughout the organization, rapidly updating antivirus signatures
\subsubsection{Antivirus detection: Data integrity}
Data integrity antivirus functionality is designed to alert administrators to unauthorized file modifications. Unless a new software, application of an operating system patch has been installed, sudden changes in executable files may be a sign of malware infection. These systems work by maintaining a database of hash values for all files stored on the system. These archived hash values are then compared to current computed values to detect any files that were modified between the two periods.
\subsection{Applications Attacks}
\subsubsection{Buffer Overflows}
Buffer overflow vulnerabilities exist when a developer does not properly validate user input to ensure that it is of an appropriate size. Input that is too large can “overflow” a data structure to affect other data stored in the computer’s memory. A web form has a field that ties to a backend variable that allows 10 characters. The form processor doesnot verify the length of the input.
\subsubsection{Time of Check to Time of Use}
 The time of check to time of use (TOCTTOU or TOC/TOU) issue is a timing vulnerability that occurs when a program checks access permissions too far in advance of a resource request. If an operating system builds a comprehensive list of access permissions for a user upon logon and then consults that list throughout the logon session, a TOCTTOU vulnerability exists.  If the system administrator revokes a particular permission, that restriction would not be applied to the user until the next time they log on.
 \subsubsection{Back Doors}
 Back doors are undocumented command sequences that allow individuals with knowledge of the back door to bypass normal access restrictions.  Backdoors can be created by malicious code on infected systems. Backdoors can be created by software developers on systems.
\subsection{Escalation of Privilege and Rootkits}
An Escalation-of-privilege attack occurs when an attacker expands his access from a normal user account to more administrative access. Rootkits exploit known vulnerabilities in various operating systems and provide the hacker that connects to the system the possibility to increase his access to the root (or administrator) level.
\subsection{Web Applicaiton attack}
\subsubsection{Cross-Site Scripting (XSS)}
Cross-site scripting (XSS) attacks occur when web applications perform reflection. Scripts can be embedded in web pages by using the HTML tags <SCRIPT> and </SCRIPT>. A successful attack can allow the attacker to execute HTML and JavaScript in the victim's browser.\\
Example: Consider a simple web application that contains a single text box asking a user to enter his name. When the user clicks Submit, the web application loads a new page that says, “Hello, name.”  Instead of entering Mike in the Name field, the following text is entered: Mike<SCRIPT>alert('hello')</SCRIPT>.  When the web application “reflects” this input in the form of a web page, the browser processes it.  It displays the text portions of the web page and executes the script portions.  A script can be included that asks the user to provide a password and transmits it to a malicious third party.
\subsubsection{Cross-Site Request Forgery (XSRF or CSRF)}
Attackers embed code in one website that sends a command to a second website.  When the user clicks the link on the first site, he or she is unknowingly sending a command to the second site.  If the user happens to be logged into that second site, the command may succeed.  XSRF attacks work by making the reasonable assumption that users are often logged into many different websites at the same time.  Those attacks are similar to cross-site scripting attacks but exploit a different trust relationship. Developers should protect their web applications against XSRF attacks.  Create web applications that use secure tokens that the attacker would not know to embed in the links. Check the referring URL in requests received from end users and only accept requests that originated from their own site.
\subsubsection{Dynamic Web Applications}
The web server is in a separate network zone called a demilitarised zone (DMZ). The database server is in the internal network, because its not meant for public access.  Web applications uses a database to create content on demand when the user makes a request. A user logs into the web application of a bank, providing an account number and password. If there is a flaw in the web application, it may allow individuals to attack the database by using SQL injection attacks.
\subsubsection{SQL Injection Attacks}
SQL injection attacks allow a malicious individual to directly perform SQL transactions against the underlying database.  Unexpected input to a web application allow an attacker to gain unauthorized access to a database. Databases will process multiple SQL statements at the same time, provided that you end each one with a semicolon. Example:  A bank customer enters an account number to gain access to a dynamic web application that retrieves current account details. The web application uses a SQL query to obtain that information, perhaps of the following form, where <number> is the account number provided by the user on the web form: $SELECT * FROM transactions WHERE account_number = '<number>$. If the user’s account number is 145249, it is possible to enter the following into the <number> field: 145249'; $DELETE * FROM transactions WHERE 'a' = 'a';$ This is a valid SQL transaction containing two statements. The first one retrieves the requested information from the database. The second statement deletes all the records stored in the database. Whoops! 

\textbf{Protection against SQL attacks} \\
Use Prepared Statement, Limit Account Privileges,  Perform Input Validation.
\subsection{Network Security}
Why should we hack network devices?\\
Used as stepping stones, Sometimes not monitored as closely as your hosts, Something running protocols designed back in the 80's, Take advantage of features like port mirorring, tunneling to infiltrate and exfriltrate data.   
\subsubsection{Denial-of-service attack (DoS)}
A denial-of-service (DoS) attack is a resource consumption attack that has the primary goal of preventing legitimate activity on a victimized system. \\
\includegraphics[width=0.75\linewidth]{dosattack}
\subsection{SYN flooding}
Send TCP SYN segments to open ports with a spoofed source IP address. Server replies with SYN/ACK to spoofed source. Half-open connections till the server cannot accept new connections.
\subsubsection{Service request floods}
Request service fro the application with the goal to exhaust server resources.
\subsubsection{Application level DOS}
Attacks exploiting a vulnerability in hardware or software.  It is not about the quantity but the quality. This exploitation of a weakness or error causes a system to crash, hang, freeze or consume all system resources.

\subsubsection{Botnets}
A botnet is a logical collection of Internet-connected devices such as computers, smartphones or IoT devices whose security have been breached and control ceded to a third party. The attacker installs remote-control tools onto these zombies (remote C\&C (Command \&Control)).

\includegraphics[width=0.75\linewidth]{botnet}
\subsubsection{Distributed DoS (DDoS)}
The controller of a botnet is able to direct the activities of these compromised computers.  In response to a launch command from the botmaster, each Zombie conducted a DoS attack against the victim. The victim may be able to discover zombie systems that are causing the DoS attack but won’t be able to track down the actual attacker.
\subsubsection{Man-in-the-Middle attacks}
The attacker inserts itself in-between the client and the server. The attacker can now view and control all network traffic.
\subsubsection{Eavesdropping}
 Eavesdropping is simply listening to communication traffic for the purpose of duplicating it.  Eavesdropping is often facilitated by the use of a network traffic capture or monitoring program or a protocol analyzer system (often called a sniffer). Eavesdropping devices and software are usually difficult to detect because they are used in passive attacks.
\subsubsection{Impersonation/masquerading}
Impersonation, or masquerading, is the act of pretending to be someone or something you are not to gain unauthorized access to a system.  This usually implies that authentication credentials have been stolen or falsified in order to satisfy authentication mechanisms. This is different from spoofing, where an entity puts forth a false identity but without any proof (such as using an false IP address, MAC addresses, email address, system name, domain name, etc.).
\subsubsection{Replay Attack}
Replay attacks attempt to reestablish a communication session by replaying captured traffic against a system. Replay attacks are made possible through capturing network traffic via eavesdropping.
\subsubsection{Modification Attacks}
In modification attacks, captured packets are altered and then played against a system.  Modified packets are designed to bypass the restrictions of improved authentication mechanisms and session sequencing.
\subsubsection{Session IDs}
Session IDs are used to establish a "stateful" connection between web client and web server.  Stored in cookies, passed in URL or stored in "hidden fields".  Sometimes also used for authentication and authorization to avoid to re-enter the password
\subsubsection{Session hijacking with sessions predicting}
The attacker watches session IDs for pattern and tries to predict.  The attacker tries many session IDs based on known sessions.  Possibility of a session ID brute force attack where the attacker tries thousand of guesses per second.
\subsubsection{Session hijacking with session Fixation}
The attacker uses an established connection and tries to get the victim to use to connection. Once the client has established the session, the session can be hijacked by the attacker.
\subsubsection{Session hijacking with Cross-Site Scripting}
\includegraphics{xsshijack}
\subsubsection{Session hijacking with TCP/IP hijacking}
The hijack takes place after step 2.  The attacker responds quicker to the server than the client.  Often an attacker sends first to the client a RST packet using spoofed server IP address in order to force a new 3-way handshake. \\
\includegraphics[width=\linewidth]{tcpiphijack}